/******************************************************************************/
/* Sistemas Integrados TEKNISA                                                */
/*                                                                            */
/* Trigger  : 0039_FINTRG_DTULTATUMPRO_MOTIVOPROR                             */
/* Tabela   : MOTIVOPROR                                                      */
/* Descrio:                                                                 */
/* Trigger para atualizao do campo DTULTATUMPRO da tabela MOTIVOPROR.       */
/*                                                                            */
/* Criao:                                                                   */
/* 13/10/2005 - Mariana Costa                                                 */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_PROR
BEFORE INSERT OR UPDATE OR DELETE
ON MOTIVOPROR FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUMPRO    := SYSDATE;
   END IF;
   IF UPDATING THEN

      IF (NVL(:OLD.CDMOTIPROR,0)   <> NVL(:NEW.CDMOTIPROR,0))   OR
         (NVL(:OLD.DSMOTIPROR,0)   <> NVL(:NEW.DSMOTIPROR,0)) THEN
         :NEW.DTULTATUMPRO := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN

      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('MOTIVOPROR', '', 'CDMOTIPROR='||:OLD.CDMOTIPROR||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE MOTIVOPROR MODIFY DTULTATUMPRO DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_PROR','4.09.066'); END;
/

